@warnings
@script channel
@version 2.0

var a=0;
var b=0;
var cameraname;
var objectname;
var tobject;
var camera;
var ec;
var f=0;
var exposename;

expose fstop, focaldistance, focallength as cam;

create: channel
{
	setdesc("Rack Focus");
	if(exposename == "None" || exposename == nil)
		ec = getfirstitem(CAMERA);
	else
		ec = getfirstitem(exposename);
	if(channel.name!="FocalDistance")
	{
		warn("Apply to Focal Distance Channels only.");
		return;
	}
}

process: ca, frame, time
{
	if(camera == nil)
	{
		camera = getfirstitem(cameraname);
	}

	if(tobject == nil)
	{
		tobject = getfirstitem(objectname);
	}

	if(tobject != nil && camera != nil)
	{	
		camwpos = camera.getWorldPosition(time);
		towpos = tobject.getWorldPosition(time);
		f = vmag(extent(towpos,camwpos));
		ca.set(f);
		cam$fstop = ec.fStop(time);
		cam$focallength = ec.focalLength(time);
		cam$focaldistance = f;
	}
}

options
{
	if(!reqbegin("Select Camera and Focus Object"))
		return;

	focuscamera = ctlcameraitems("Focus Source",camera);
	focusobject = ctlmeshitems("Focus Object",tobject);
	exposecam = ctlcameraitems("DOFtoAlpha IPC Camera",ec);

	if(reqpost())
	{
		tobject = getvalue(focusobject);
		camera = getvalue(focuscamera);
		ec = getvalue(exposecam);
	}

	if(tobject != nil) objectname = tobject.name;
		else objectname = "None";
	if(camera != nil) cameraname = camera.name;
		else cameraname = "None";
	setdesc(cameraname," >> ",objectname);
}

load: what, io
{
	var items[2];
	var line;
	if(what == SCENEMODE)
	{
		lineCount = 2;
		for(i=1;i<=3;++i)
		{
			line = io.read();
			items = parse("_",line);
			if(items[1] == "FocusCamera")
			{
				cameraname = items[2];
			}
			if(items[1] == "FocusObject")
			{
				objectname = items[2];
			}
			if(items[1] == "ExposeCamera")
			{
				exposename = items[2];
			}
		}
	}
}

save: what, io
{
	if(what == SCENEMODE)
	{
		io.writeln("FocusCamera_",cameraname);
		io.writeln("FocusObject_",objectname);
		io.writeln("ExposeCamera_",ec.name);
	}
}

destroy
{
	cameraname = nil;
	objectname = nil;
	exposename = nil;
	camera = nil;
	tobject = nil;
	cam$fstop = nil;
	cam$focallength = nil;
	cam$focaldistance = nil;
	
}
